# Generated by go2rpm
%bcond_with check

%global source_date_epoch_from_changelog Y

# https://github.com/rfjakob/gocryptfs
%global goipath         github.com/rfjakob/gocryptfs
Version:                2.5.2
%global extractdir      gocryptfs_v2.5.2_src

%gometa

%global common_description %{expand:
Encrypted overlay filesystem written in Go.}

%global golicenses      LICENSE
%global godocs          README.md

Name:           %{goname}
Release:        1%{?dist}
Summary:        Encrypted overlay filesystem written in Go

License:        MIT
URL:            %{gourl}
Source0:        https://%{goipath}/releases/download/v%{version}/gocryptfs_v%{version}_src.tar.gz

BuildRequires:  golang(github.com/aperturerobotics/jacobsa-crypto/siv)
BuildRequires:  golang(github.com/hanwen/go-fuse/v2/fuse)
BuildRequires:  golang(github.com/hanwen/go-fuse/v2/fuse/nodefs)
BuildRequires:  golang(github.com/hanwen/go-fuse/v2/fuse/pathfs)
BuildRequires:  golang(github.com/moby/sys/mountinfo)
BuildRequires:  golang(github.com/pkg/xattr)
BuildRequires:  golang(github.com/rfjakob/eme)
BuildRequires:  golang(github.com/sabhiram/go-gitignore)
BuildRequires:  golang(github.com/spf13/pflag)
BuildRequires:  golang(golang.org/x/crypto/hkdf)
BuildRequires:  golang(golang.org/x/crypto/scrypt)
BuildRequires:  golang(golang.org/x/crypto/ssh/terminal)
BuildRequires:  golang(golang.org/x/sync/syncmap)
BuildRequires:  golang(golang.org/x/sys/unix)
BuildRequires:  openssl-devel

%description
%{common_description}

%gopkg

%package -n gocryptfs
Summary:       %{summary}
Requires:  fuse3

%description -n gocryptfs
%{common_description}

%package -n gocryptfs-xray
Summary:       %{summary}

%description -n gocryptfs-xray
%{common_description}

This package contains the xray tool.

%prep
%goprep

%build
USVERSION=$(cat VERSION)
GCVERSION=$USVERSION-Fedora-%{version}-%{release}
#if 0%{?fedora} > 38
#FUSEVERSION=$(rpm -q golang-github-hanwen-fuse-2-devel --queryformat '%%{version}')
#else
FUSEVERSION=$(rpm -q golang-github-hanwen-fuse-devel --queryformat '%%{version}')
#endif
BUILDDATE=$(date +%Y-%m-%d -d @$SOURCE_DATE_EPOCH)
# bex - notice the space here - it is needed and silly see https://pagure.io/go-rpm-macros/issue/19
LDFLAGS="-X main.GitVersion=$GCVERSION -X main.GitVersionFuse=$FUSEVERSION -X main.BuildDate=$BUILDDATE "
%gobuild -o %{gobuilddir}/bin/gocryptfs %{goipath}
for cmd in gocryptfs-xray; do
  %gobuild -o %{gobuilddir}/bin/$(basename $cmd) %{goipath}/$cmd
done

%install
%gopkginstall
install -m 0755 -vd                     %{buildroot}%{_bindir}
install -m 0755 -vp %{gobuilddir}/bin/* %{buildroot}%{_bindir}/
install -D -m 644 Documentation/gocryptfs.1 %{buildroot}%{_mandir}/man1/gocryptfs.1
install -D -m 644 Documentation/gocryptfs-xray.1 %{buildroot}%{_mandir}/man1/gocryptfs-xray.1

%if %{with check}
%check
%gocheck
%endif

%files -n gocryptfs
%license LICENSE
%doc README.md
%{_bindir}/gocryptfs
%{_mandir}/man1/gocryptfs.1*

%files -n gocryptfs-xray
%license LICENSE
%{_bindir}/gocryptfs-xray
%{_mandir}/man1/gocryptfs-xray.1*

%gopkgfiles

%changelog
* Sat Mar 22 2025 <nucleo@fedoraproject.org> - 2.5.2-1
- Upgrade to 2.5.2

* Thu Jan 23 2025 <nucleo@fedoraproject.org> - 2.5.1-1
- Upgrade to 2.5.1

* Thu Apr  4 2024 <nucleo@fedoraproject.org> - 2.4.0-5
- Rebuild for go-fuse 2.5.1

* Sat Feb 24 2024 <nucleo@fedoraproject.org> - 2.4.0-4
- Rebuild for go-fuse 2.5.0

* Thu Nov 16 2023 <nucleo@fedoraproject.org> - 2.4.0-3
- Rebuild for go-fuse 2.4.2 jacobsa-crypto-1.0.2

* Wed Sep 13 2023 <nucleo@fedoraproject.org> - 2.4.0-2
- Rebuild for go-fuse 2.4.0

* Sun Jun 11 2023 <nucleo@fedoraproject.org> - 2.4.0-1
- Upgrade to 2.4.0

* Sat Apr 29 2023 <nucleo@fedoraproject.org> - 2.3.2-1
- Upgrade to 2.3.2

* Mon Apr 10 2023 <nucleo@fedoraproject.org> - 2.3.1-1
- Upgrade to 2.3.1

* Sun Jul 10 2022 Robert-André Mauchin <zebob.m@gmail.com> - 1.8.0-6
- Rebuild for CVE-2022-{24675,28327,29526 in golang}

* Thu Jul 22 2021 Fedora Release Engineering <releng@fedoraproject.org> - 1.8.0-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Tue Jan 26 2021 Fedora Release Engineering <releng@fedoraproject.org> - 1.8.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Mon Jul 27 2020 Fedora Release Engineering <releng@fedoraproject.org> - 1.8.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Mon Jul 27 2020 Robert-André Mauchin <zebob.m@gmail.com> - 1.8-2
- Update go-fuse import path

* Thu May 21 2020 Brian (bex) Exelbierd <bex@pobox.com> - 1.8-1
- Upgrade to 1.8

* Wed Jan 29 2020 Fedora Release Engineering <releng@fedoraproject.org> - 1.7-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Sat Aug 10 2019 Brian Exelbierd <bexelbie@redhat.com> - 1.7-3
- Fix requires

* Thu Jul 25 2019 Fedora Release Engineering <releng@fedoraproject.org> - 1.7-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Sun Jun 23 11:36:48 CEST 2019 Brian (bex) Exelbierd <bex@pobox.com> - 1.7-1
- Initial package
